#!/bin/sh
# Begin libkernel.sh

include common
include color
include pretty

function module_load()
{
    Section "Loading modules"
    for i in $*
    do
      Elt "$i"
      # TODO : Test that this is a complete check against malicious code :
      if matches "$i" '/[a-zA-Z0-9_]\+/'; then
	  # $i is supposed to contain only non-pathologic chars
	  if lsmod | grep "^$i " > /dev/null 2>&1; then
	      print_info "Already loaded"
	      print_status noop
	      Feed
	  else
	      if [ "$(modprobe -l '$i.*' 2> /dev/null)" == "" ]; then
		  print_info "Module not found"
		  print_status failure
		  Feed
	      else
		  print_info "Module found..."
		  modprobe -q "$i" >/dev/null 2>&1
		  Feedback
	      fi
	  fi
      else
	  print_info "Bad module string"
	  print_status failure
	  Feed
      fi
      
    done
    return 0;
}


function kernel_vars
{

    depends sysctl
    Section "Setting kernel vars"

    while test "$1";do
	Elt "$1 -> '${YELLOW}$2${NORMAL}'"
	if test -f "/proc/sys/$1" ; then
	    if test "$2"; then
		if [ "$2" != "$(sysctl -n $1)" ]; then
		    print_info "Was '$(sysctl -n $1)'"
		    sysctl -w $1=$2 >/dev/null 2>&1
		    Feedback
		else
		    print_info "Already done"
		    print_status noop
		    Feed

		fi
	    else
 		print_info "Bad value"
		print_status failure
		Feed
	    fi
	else
	    print_info "Var doesn't exist"
	    print_status failure
	    Feed
	fi
	shift
	shift
    done
}



# End libkernel.sh
